--[==[

Copyright ©2019 Samuel Thomas Pain

The contents of this addon, excluding third-party resources, are
copyrighted to their authors with all rights reserved.

This addon is free to use and the authors hereby grants you the following rights:

1. 	You may make modifications to this addon for private use only, you
    may not publicize any portion of this addon.

2. 	Do not modify the name of this addon, including the addon folders.

3. 	This copyright notice shall be included in all copies or substantial
    portions of the Software.

All rights not explicitly addressed in this license are reserved by
the copyright holders.

]==]--


local name, GHC = ...

SLASH_GUILDHELPERCLASSIC1 = '/ghc'
SlashCmdList['GUILDHELPERCLASSIC'] = function(msg)

    if msg == 'help' then
        print('helping :/')
    end

end

--many of these no longer used, look to review and reduce
GHC.UI = { 
    GuildRosterListViewItemFontSizeLarge = 14.0, 
    GuildRosterListViewItemFontSizeSmall = 11.0, 
    DetailFrameIconSize = 40.0, 
    DetailFrameBottomRowY = -280, 
    DetailFrameMiddleRowY = -180, 
    DetailFrameTopRowY = -80,
    ClassSummaryBarHeight = 25.0,
    ClassSummaryBarWidth = 150.0 
}

GHC.UI.ParentFrame = CreateFrame("FRAME", "GHC_ParentFrame", GuildFrame)
GHC.UI.ParentFrame:SetPoint("TOPLEFT", 350, -12)
GHC.UI.ParentFrame:SetBackdrop({ edgeFile = "interface/dialogframe/ui-dialogbox-border", tile = true, tileSize = 16, edgeSize = 20, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GHC.UI.ParentFrame:SetSize(650, 500)
GHC.UI.ParentFrame.Texture = GHC.UI.ParentFrame:CreateTexture('$parent_Texture', 'BACKGROUND')
GHC.UI.ParentFrame.Texture:SetTexture("interface/dialogframe/ui-dialogbox-background")
GHC.UI.ParentFrame.Texture:SetPoint('TOPLEFT', 4, -4)
GHC.UI.ParentFrame.Texture:SetPoint('BOTTOMRIGHT', -4, 4)

GHC.UI.RosterScrollFrame = CreateFrame("SCROLLFRAME", "GHC_GuildRosterScrollframe", GHC.UI.ParentFrame)
GHC.UI.RosterScrollFrame:SetPoint("TOPLEFT", 0, -44)
GHC.UI.RosterScrollFrame:SetSize(300, 450)

GHC.UI.RosterScrollBar = CreateFrame("Slider", "AJ_ConsumablesListViewFrame_ScrollFrame", GHC.UI.RosterScrollFrame, "UIPanelScrollBarTemplate")
GHC.UI.RosterScrollBar:SetPoint("TOPLEFT", GHC.UI.RosterScrollFrame, "TOPRIGHT", 0, -22) 
GHC.UI.RosterScrollBar:SetPoint("BOTTOMLEFT", GHC.UI.RosterScrollFrame, "BOTTOMRIGHT", 0, 22)
GHC.UI.RosterScrollBar:SetMinMaxValues(1, 10)
GHC.UI.RosterScrollBar:SetValueStep(1.0)
GHC.UI.RosterScrollBar.scrollStep = 1
GHC.UI.RosterScrollBar:SetValue(1)
GHC.UI.RosterScrollBar:SetWidth(16)
GHC.UI.RosterScrollBar:SetScript('OnValueChanged', function(self, value) GHC.Functions.GuildRosterScrollBarChanged(value) end)

GHC.GuildRosterListViewItems = {}
function GHC.UI.DrawGuildRosterListview()
    for i = 1, 10 do
        local f = CreateFrame("FRAME", tostring("GHC_GuildRosterListViewItem"..i), GHC.UI.RosterScrollFrame)
        f:SetPoint("TOPLEFT", 12, ((44 * (i - 1)) * -1) - 4)
        f:SetSize(280, 44)
        f:SetBackdrop({ bgFile = "Interface/Tooltips/UI-Tooltip-Background", insets = { left = 2, right = 2, top = 2, bottom = 2 } })
        f:SetBackdropColor(0, 0, 0, 1.0)

        f.RaceIcon = CreateFrame("FRAME", tostring("GHC_GuildRosterListViewItem"..i.."_RaceIcon"), f)
        f.RaceIcon:SetPoint("LEFT", 6, 0)
        f.RaceIcon:SetSize(32, 32)
        f.RaceIcon.Texture = f.RaceIcon:CreateTexture("$parent_Background", "BACKGROUND")
        f.RaceIcon.Texture:SetAllPoints(f.RaceIcon)

        f.RoleText = f:CreateFontString(tostring("GHC_GuildRosterListViewItem"..i.."_RoleText"), "OVERLAY", "GameFontNormal")
        f.RoleText:SetPoint("TOPLEFT", 54, -26)
        
        f.ClassIcon = CreateFrame("FRAME", tostring("GHC_GuildRosterListViewItem"..i.."_RaceIcon"), f)
        f.ClassIcon:SetPoint("RIGHT", -2, -2)
        f.ClassIcon:SetSize(40, 40)
        f.ClassIcon.Texture = f.ClassIcon:CreateTexture("$parent_Background", "BACKGROUND")
        f.ClassIcon.Texture:SetAllPoints(f.ClassIcon)

        f.Name = f:CreateFontString(tostring("GHC_GuildRosterListViewItem"..i.."_NameText"), 'OVERLAY', 'GameFontNormal')
        f.Name:SetPoint("TOPLEFT", 52, -6)
        f.Name:SetTextColor(1,1,1,1)
        f.Name:SetFont("Fonts\\FRIZQT__.TTF", tonumber(GHC.UI.GuildRosterListViewItemFontSizeLarge))

        f.Level = f:CreateFontString(tostring("GHC_GuildRosterListViewItem"..i.."_LevelText"), 'OVERLAY', 'GameFontNormal')
        f.Level:SetPoint("TOPRIGHT", -52, -6)
        f.Level:SetTextColor(1,1,1,1)
        f.Level:SetFont("Fonts\\FRIZQT__.TTF", tonumber(GHC.UI.GuildRosterListViewItemFontSizeLarge))

        f.Profession1Icon = CreateFrame("FRAME", tostring("GHC_GuildMemberDetailFrame_Profession1Icon"), f)
        f.Profession1Icon:SetPoint("TOPRIGHT", -64, -24)
        f.Profession1Icon:SetSize(16, 16)
        f.Profession1Icon.Texture = f.Profession1Icon:CreateTexture("$parent_Background", "BACKGROUND")
        f.Profession1Icon.Texture:SetAllPoints(f.Profession1Icon)
        f.Profession1 = nil
        f.Profession1Icon:SetScript("OnEnter", function() print(f.Profession1) end)
        f.Profession1Icon:SetScript("OnLeave", function()  end)

        f.Profession2Icon = CreateFrame("FRAME", tostring("GHC_GuildMemberDetailFrame_Profession2Icon"), f)
        f.Profession2Icon:SetPoint("TOPRIGHT", -44, -24)
        f.Profession2Icon:SetSize(16, 16)
        f.Profession2Icon.Texture = f.Profession2Icon:CreateTexture("$parent_Background", "BACKGROUND")
        f.Profession2Icon.Texture:SetAllPoints(f.Profession2Icon)
        f.Profession2 = nil
        f.Profession2Icon:SetScript("OnEnter", function() print(f.Profession2) end)
        f.Profession2Icon:SetScript("OnLeave", function()  end)
        
        --f:SetScript("OnEnter", function(self)  end)
        --f.Profession1Icon.Texture:SetTexture(136243)
        --f.Profession2Icon.Texture:SetTexture(136243)

        GHC.GuildRosterListViewItems[i] = f
    end
end

GHC.UI.GuildSummaryFrame = CreateFrame("FRAME", "GHC_GuildSummaryFrame", GHC.UI.ParentFrame)
GHC.UI.GuildSummaryFrame:SetBackdrop({ edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 20, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GHC.UI.GuildSummaryFrame:SetPoint("TOPLEFT", 350, -44)
GHC.UI.GuildSummaryFrame:SetSize(280, (GHC.UI.ClassSummaryBarHeight * 10) + 16)

GHC.UI.GuildSummaryFrameTitle = GHC.UI.GuildSummaryFrame:CreateFontString("GHC_GuildSummaryTitle", 'OVERLAY', 'GameFontNormal')
GHC.UI.GuildSummaryFrameTitle:SetPoint("TOP", 0, -8)
GHC.UI.GuildSummaryFrameTitle:SetText("Class Summary")
GHC.UI.GuildSummaryFrameTitle:SetTextColor(1,1,1,1)
GHC.UI.GuildSummaryFrameTitle:SetFont("Fonts\\FRIZQT__.TTF", tonumber(GHC.UI.GuildRosterListViewItemFontSizeLarge))

GHC.UI.ClassSummaryBars = {}
function GHC.UI.DrawGuildClassSummaryBars()
    for k, v in ipairs(GHC.Db.ClassIDs) do
        local f = CreateFrame("FRAME", tostring("GHC_GuildSummaryClassFrame"..k), GHC.UI.GuildSummaryFrame)
        f:SetSize(260, 44)
        f:SetPoint("TOPLEFT", 8, (k * GHC.UI.ClassSummaryBarHeight) * -1)

        f.Icon = CreateFrame("FRAME", tostring("GHC_GuildSummaryClassFrame_Icon"..k), f)
        f.Icon:SetPoint("LEFT", 4, 0)
        f.Icon:SetSize(GHC.UI.ClassSummaryBarHeight, GHC.UI.ClassSummaryBarHeight)
        f.Icon.Texture = f.Icon:CreateTexture("$parent_Background", "BACKGROUND")
        f.Icon.Texture:SetAllPoints(f.Icon)
        f.Icon.Texture:SetTexture(tostring("Interface/Addons/GuildHelperClassic/ClassIcons/"..v))

        f.Text = f:CreateFontString(tostring("GHC_GuildSummaryClassFrame_Name"..k), 'OVERLAY', 'GameFontNormal')
        f.Text:SetPoint("RIGHT", 0, 0)
        f.Text:SetTextColor(1,1,1,1)
        f.Text:SetFont("Fonts\\FRIZQT__.TTF", tonumber(GHC.UI.GuildRosterListViewItemFontSizeSmall))
        f.Text:SetText(v)  
        
        f.StatusBar = CreateFrame("StatusBar", tostring("GHC_GuildSummaryClassFrame_StatusBar"..k), f)
        f.StatusBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
        f.StatusBar:GetStatusBarTexture():SetHorizTile(false)
        f.StatusBar:SetMinMaxValues(0, 100)
        f.StatusBar:SetSize(GHC.UI.ClassSummaryBarWidth, GHC.UI.ClassSummaryBarHeight * 0.9)
        f.StatusBar:SetPoint('LEFT', 40, 0)
        f.StatusBar:SetStatusBarColor(GHC.Db.ClassColours[v].r, GHC.Db.ClassColours[v].g, GHC.Db.ClassColours[v].b)	

        GHC.UI.ClassSummaryBars[k] = f
    end
end


GHC.UI.PlayerOptionsFrame = CreateFrame("FRAME", "GHC_PlayerOptionsFrame", GHC.UI.ParentFrame)
GHC.UI.PlayerOptionsFrame:SetBackdrop({ edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 20, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GHC.UI.PlayerOptionsFrame:SetPoint("TOPLEFT", 350, -310)
GHC.UI.PlayerOptionsFrame:SetSize(280, 180)

GHC.UI.PlayerOptionsFrame.Header = GHC.UI.PlayerOptionsFrame:CreateFontString("GHC_PlayerOptionsFrame_Header", 'OVERLAY', 'GameFontNormal')
GHC.UI.PlayerOptionsFrame.Header:SetPoint("TOP", 0, -8)
GHC.UI.PlayerOptionsFrame.Header:SetText("Options")
GHC.UI.PlayerOptionsFrame.Header:SetTextColor(1,1,1,1)
GHC.UI.PlayerOptionsFrame.Header:SetFont("Fonts\\FRIZQT__.TTF", tonumber(GHC.UI.GuildRosterListViewItemFontSizeLarge))

GHC.UI.PlayerOptionsFrame.Info = GHC.UI.PlayerOptionsFrame:CreateFontString("GHC_PlayerOptionsFrame_Header", 'OVERLAY', 'GameFontNormal')
GHC.UI.PlayerOptionsFrame.Info:SetPoint("TOP", 0, -28)
GHC.UI.PlayerOptionsFrame.Info:SetSize(240, 50)
GHC.UI.PlayerOptionsFrame.Info:SetText("The addon works best when you share your character information with your guild, this includes race, gender and professions but |cffC41F3BNOT|r talents.")
GHC.UI.PlayerOptionsFrame.Info:SetTextColor(1,1,1,1)
GHC.UI.PlayerOptionsFrame.Info:SetFont("Fonts\\FRIZQT__.TTF", tonumber(GHC.UI.GuildRosterListViewItemFontSizeSmall))

GHC.UI.PlayerOptionsFrame.PlayerRoleDropdown = CreateFrame("FRAME", "GHC_PlayerRoleDropdown", GHC.UI.PlayerOptionsFrame, "UIDropDownMenuTemplate")
GHC.UI.PlayerOptionsFrame.PlayerRoleDropdown:SetPoint("TOPLEFT", 0, -100)
GHC.UI.PlayerOptionsFrame.PlayerRoleDropdown.displayMode = nil --"MENU"
UIDropDownMenu_SetWidth(GHC.UI.PlayerOptionsFrame.PlayerRoleDropdown, 100)
UIDropDownMenu_SetText(GHC.UI.PlayerOptionsFrame.PlayerRoleDropdown, 'Role')
function GHC.UI.PlayerOptionsFrame.PlayerRoleDropdown_Init()
	UIDropDownMenu_Initialize(GHC.UI.PlayerOptionsFrame.PlayerRoleDropdown, function(self, level, menuList)
		local info = UIDropDownMenu_CreateInfo()
		if (level or 1) == 1 then
			for k, role in ipairs(GHC.Db.Roles) do
                info.text = role.Text
                info.arg1 = role.Id
                info.arg2 = nil						
                info.func = function() GhcDb[UnitGUID('player')].Settings.Role = role.Id end
                if GhcDb ~= nil and  GhcDb[UnitGUID('player')].Settings.Role == role.Id then
                    info.checked = true
                else
                    info.checked = false
                end
                info.isNotRadio = true
                --info.hasArrow = true
                --info.menuList = class.MenuList
                UIDropDownMenu_AddButton(info)
			end
		end
	end)
end

GHC.UI.PlayerOptionsFrame.SendMyDataButton = CreateFrame("BUTTON", "GHC_SendMyDataButton", GHC.UI.PlayerOptionsFrame, "UIPanelButtonTemplate")
GHC.UI.PlayerOptionsFrame.SendMyDataButton:SetPoint("TOPLEFT", 160, -100)
GHC.UI.PlayerOptionsFrame.SendMyDataButton:SetText('Send My Data')
GHC.UI.PlayerOptionsFrame.SendMyDataButton:SetSize(100, 22)
GHC.UI.PlayerOptionsFrame.SendMyDataButton:SetScript("OnClick", function() GHC.Functions.SendMyData() end)

GHC.UI.PlayerOptionsFrame.ScanGuildRosterButton = CreateFrame("BUTTON", "GHC_ScanGuildRosterButton", GHC.UI.PlayerOptionsFrame, "UIPanelButtonTemplate")
GHC.UI.PlayerOptionsFrame.ScanGuildRosterButton:SetPoint("TOPLEFT", 160, -150)
GHC.UI.PlayerOptionsFrame.ScanGuildRosterButton:SetText('Scan Roster')
GHC.UI.PlayerOptionsFrame.ScanGuildRosterButton:SetSize(100, 22)
GHC.UI.PlayerOptionsFrame.ScanGuildRosterButton:SetScript("OnClick", function() GHC.Functions.ScanGuildRoster() end)

function GHC.OnEvent(self, event, ...)

    --standard addon loaded events, register addon chat channel prefix, after 1 second delay (allowing for GUIDs) draw and load data
    if event == "ADDON_LOADED" and select(1, ...) == "GuildHelperClassic" then
        if C_ChatInfo.RegisterAddonMessagePrefix("ghc-playerdata") then			
			GHC.Functions.PrintMessage('addon channel prefix registration successful!')
		else
			GHC.Functions.PrintMessage('addon channel prefix registration failed!')		
		end

        local t = C_Timer.After(1, function() 
            GHC.UI.DrawGuildRosterListview() 
            GHC.UI.DrawGuildClassSummaryBars() 
            GHC.Functions.Load() 
            GHC.UI.PlayerOptionsFrame.PlayerRoleDropdown_Init()
        end)

    end

    --when a guild member sends data this catches it and sends it to parser
	if event == 'CHAT_MSG_ADDON' and select(1, ...) == 'ghc-playerdata' then
		local msg = select(2, ...)
		local sender = select(5, ...)
        GHC.Functions.ParsePlayerData(msg)
    end
    
    --update the addon UI
    if event == 'GUILD_ROSTER_UPDATE' then
        if GhcDb[UnitGUID('player')].GuildDb ~= nil then
            if GHC.UI.ParentFrame:IsVisible() then
                GHC.Functions.ScanGuildRoster()
            end
        end
    end
    
end

GHC.UI.ParentFrame:RegisterEvent("ADDON_LOADED")
GHC.UI.ParentFrame:RegisterEvent('CHAT_MSG_ADDON')
GHC.UI.ParentFrame:RegisterEvent('GUILD_ROSTER_UPDATE')

GHC.UI.ParentFrame:SetScript("OnEvent", GHC.OnEvent)
GHC.UI.ParentFrame:SetScript("OnShow", GHC.Functions.ScanGuildRoster)